// includes //
#include <windows.h>
#include <commctrl.h>
#include <shlobj.h>
#include "resource.h"
#include "myrt.h"

/* MEMO *
IOCTL_SERIAL

ʃR}hAl
OK = 0x06
NG = 0x08?0x18Ȃ
A肪2oCgȏ̎0x06𑗐MȂႢȂۂB(@擾Ƃ)
ʐMI0x04𑗐MClose.
* MEMO END */

// GlobalDefine //
HWND hMainWnd;
HWND hFilesWnd = 0;

// Useful serial functions //
BOOL Write(HANDLE hFile, LPCVOID ptr, DWORD byte)
{
	DWORD bytes;
	DWORD tick;
	DWORD wrote = 0;

	tick = GetTickCount();

	while(wrote < byte)
	{
		WriteFile(hFile, (char*)ptr + wrote, byte - wrote, &bytes, NULL);
		wrote += bytes;
		if((tick + 5000) < GetTickCount())	// TIMEOUT!!
			return TRUE;
	}

	return FALSE;
}

BOOL WriteByte(HANDLE hFile, BYTE byte)
{
	return Write(hFile, &byte, 1);
}

BOOL Read(HANDLE hFile, LPVOID ptr, DWORD byte)
{
	DWORD bytes;
	DWORD read = 0;
	DWORD tick;

	tick = GetTickCount();

	while(read < byte)
	{
		ReadFile(hFile, (char*)ptr + read, byte - read, &bytes, NULL);
		read += bytes;
		if((tick + 5000) < GetTickCount())	// TIMEOUT!!
			return TRUE;
	}

	return FALSE;
}

WORD ReadByte(HANDLE hFile)
{
	BYTE ret;

	if(Read(hFile, &ret, 1))
		return 0x0100;

	return (WORD)ret;
}

BOOL sendCommand(HANDLE hFile, BYTE* ptr, DWORD byte, BOOL isdata)
{
	unsigned char tmp[5];
	DWORD i;
	DWORD left = byte;

	do
	{
		unsigned short sum = 0xFFFF;
		WORD pktsize = (left > 4095 - 5 - 3) ? (4095 - 5 - 3) : (WORD)left;

		tmp[0] = 0x01;
		if(isdata)
			tmp[1] = 0x80;	// data
		else
			tmp[1] = 0x00;	// command
		tmp[2] = (unsigned char)((1 + pktsize + 3) >> 8) & 0xFF;
		tmp[3] = (unsigned char)(1 + pktsize + 3) & 0xFF;
		tmp[4] = 0x02;
		if(Write(hFile, tmp, 5))
			return TRUE;	// head send failed

		for(i = 0; i < 5; i++)
			sum -= tmp[i];

		if(ptr && pktsize)	// for 0byte packet.
			if(Write(hFile, ptr, pktsize))
				return TRUE;	// data send failed

		for(i = 0; i < pktsize; i++)
			sum -= ((unsigned char*)ptr)[i];

		left -= pktsize;
		ptr += pktsize;

		if(!left)	// left=0 == last
			tmp[0] = 0x03;
		else
			tmp[0] = 0x17;
		sum -= tmp[0];
		tmp[1] = (unsigned char)(sum >> 8) & 0xFF;
		tmp[2] = (unsigned char)sum & 0xFF;
		if(Write(hFile, tmp, 3))
			return TRUE;	// foot send failed

		if(left)
			if(ReadByte(hFile) != 0x06)
				return TRUE;
	}
	while(left);

	return FALSE;
}

BOOL getResultWC(HANDLE hCom, BYTE** retbuf, DWORD* retsize, void (*callback)(DWORD, LPARAM), LPARAM lpdata)
{
	WORD size;
	BYTE buf[2];
	BYTE* data = NULL;

	*retsize = 0;

	for(;;)
	{
		WORD chksum = 0xFFFF;
		WORD datacs;
		WORD i;

		if(callback)
			callback(*retsize, lpdata);

		// header check
		if(ReadByte(hCom) != 0x01)
			goto error;
		chksum -= 0x01;
		if(ReadByte(hCom) != 0x80)
			goto error;
		chksum -= 0x80;

		// read data size
		if(Read(hCom, buf, 2))
			goto error;

		size = (buf[0] << 8) | buf[1];
		data = hrealloc(data, *retsize + size);
		chksum -= buf[0];
		chksum -= buf[1];

		// read data
		if(ReadByte(hCom) != 0x02)
			goto error;
		size--;
		chksum -= 0x02;

		if(Read(hCom, data + *retsize, size))
			goto error;

		for(i = 0; i < size - 2; i++)
			chksum -= *(data + *retsize + i);
		datacs = (data[*retsize + size - 2] << 8) | data[*retsize + size - 1];

		if(chksum != datacs)
		{
			WriteByte(hCom, 0x08);	// obsolete: if bad, what command byte we should send?
			continue;
		}

		// 0x07 need? (MySync)
		WriteByte(hCom, 0x06);	// ACK

		*retsize += size - 3;

		if(data[*retsize] == 0x17)
			continue;
		if(data[*retsize] == 0x03)
			break;

		{
			char tmp[80];

			wsprintf(tmp, "Exception: in getResult: Illegal return char: [%02X]\r\nAbort function!", data[*retsize]);
			MessageBox(NULL, tmp, "Bug or error", MB_ICONERROR | MB_OK);
		}
		goto error;
	}

	*retbuf = data;

	return FALSE;
error:
	if(data)
		hfree(data);
	*retsize = 0;

	return TRUE;
}

BOOL getResult(HANDLE hCom, BYTE** retbuf, DWORD* retsize)
{
	return getResultWC(hCom, retbuf, retsize, NULL, 0);
}

int GetDlgItemTextLength(HWND hDlg, int nIDDlgItem)
{
	return GetWindowTextLength(GetDlgItem(hDlg, nIDDlgItem));
}

void Log(LPCSTR str)
{
	char* buf;
	DWORD len;

	len = GetDlgItemTextLength(hMainWnd, IDC_DEBUG) + strlength(str) + 1;
	if(!(buf = halloc(len)))
		return;
	GetDlgItemText(hMainWnd, IDC_DEBUG, buf, len);
	strplus(buf, str);
	SetDlgItemText(hMainWnd, IDC_DEBUG, buf);
	hfree(buf);

	SendMessage(GetDlgItem(hMainWnd, IDC_DEBUG), EM_SETSEL, len, len);
	SendMessage(GetDlgItem(hMainWnd, IDC_DEBUG), EM_SCROLLCARET, 0, 0);

	RedrawWindow(GetDlgItem(hMainWnd, IDC_DEBUG), NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);

#ifdef _DEBUG
	OutputDebugString(str);
#endif

	return;
}

void LogHex(DWORD data)
{
	BYTE buf[9];

	wsprintf(buf, "%02X", data);
	Log(buf);

	return;
}

void LogDump(BYTE* ptr, DWORD size)
{
	while(size--)
	{
		LogHex(*ptr++);
		Log(" ");
	}
}

BOOL SetBaudrate(HANDLE hcom, DWORD rate)
{
	DCB dcb;
	BOOL result;

	ZeroMemory(&dcb, sizeof(dcb));
	dcb.DCBlength = sizeof(dcb);
	GetCommState(hcom, &dcb);

	dcb.BaudRate = rate;

	PurgeComm(hcom, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
	result = SetCommState(hcom, &dcb);
	PurgeComm(hcom, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);

	return result;
}

HANDLE StartSerialTransfer(LPCTSTR comport)
{
	HANDLE hcom;

	if((hcom = CreateFile(comport, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
		return NULL;

	// Setup Buffer Size
	SetupComm(hcom, 4096, 4096);

	// Set TimeOut
	{
		COMMTIMEOUTS cto;

		cto.ReadIntervalTimeout = 10;
		cto.ReadTotalTimeoutMultiplier = 1;
		cto.ReadTotalTimeoutConstant = 100;
		cto.WriteTotalTimeoutMultiplier = 1;
		cto.WriteTotalTimeoutConstant = 100;
		SetCommTimeouts(hcom, &cto);
	}

	// Set BaudRate, StopBits, BitSize, Parity....
	{
		DCB dcb;

		ZeroMemory(&dcb, sizeof(dcb));
		dcb.DCBlength = sizeof(dcb);
		GetCommState(hcom, &dcb);

		dcb.StopBits = ONESTOPBIT;
		dcb.fParity = TRUE;
		dcb.Parity = EVENPARITY;
		dcb.ByteSize = 8;

		dcb.EofChar = 0;
		dcb.ErrorChar = 0;
		// what is brk?
		dcb.fErrorChar = TRUE;	// needed?
		dcb.EvtChar = 0;
		dcb.XonChar = 0;
		dcb.XoffChar = 0;

		dcb.XoffLim = 0;
		dcb.XonLim = 0;
		SetCommState(hcom, &dcb);
	}

	SetBaudrate(hcom, 600);	// 600ċ@Ƃ̌݊?mȂB

	// need?
	PurgeComm(hcom, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);

	return hcom;
}

BOOL ChangeMode(HANDLE hcom)
{
	BYTE buf[4];

retry:
	// Mode change?
	buf[0] = 0xD0;
	buf[1] = 0x01;
	buf[2] = 0x05;
	if(Write(hcom, buf, 3))
	{
		Log("D00105 Write Failed\r\n");
		return TRUE;
	}
	buf[2] = 0x06;
	{
		DWORD c = 0;
		WORD rb;

		while(c < 3)
		{
			if((rb = ReadByte(hcom)) == 0x0100)
			{
				Log("D00105 phase Read Failed\r\n");
				return TRUE;
			}
			// if(rb & 0xF0 == 0xC0)
			if(rb == 0x8E || (0xC0 <= rb && rb <= 0xCF))	// it is dialLockOff/antenna level
				continue;
			if(rb == 0x08)
			{
				Log("Retrying...");
				goto retry;
			}
			if(buf[c] != rb)
			{
				Log("D00105 phase Mismatch(");
				LogHex(rb);
				Log(")\r\n");
				return TRUE;
			}
			c++;
		}
	}
	// here, will not come 0xC* data(antenna level) NO LONGER??

	buf[0] = 0x05;
	if(Write(hcom, buf, 1))
	{
		Log("05 Write Failed\r\n");
		return TRUE;
	}
	if(Read(hcom, buf, 1))
	{
		Log("05 Read Failed\r\n");
		return TRUE;
	}
	if(buf[0] != 0x06)
	{
		Log("05 Data Error RET=");
		LogHex(buf[0]);
		Log("\r\n");
		return TRUE;
	}

	return FALSE;
}

int setFrameSize(HANDLE hcom, DWORD framesize)
{
	BYTE buf[6];

	buf[0] = 0x00;
	buf[1] = 0x03;
	buf[2] = 0x00;
	buf[3] = 0x00;
	buf[4] = (BYTE)((framesize >> 8) & 0xFF);
	buf[5] = (BYTE)(framesize & 0xFF);

	if(sendCommand(hcom, buf, 6, FALSE))
		return 1;
	if(ReadByte(hcom) != 0x06)
		return 2;

	return 0;
}

// sub routine //
int ChangeBaudrate(HANDLE hcom, DWORD rate)
{
	unsigned char buf[32];

	// ChangeSpeed...?

	buf[0] = 0x00;
	buf[1] = 0x00;
	buf[2] = 0x00;
	buf[3] = 0x01;
	buf[4] = 0x00;
	buf[5] = 0x00;

	if(sendCommand(hcom, buf, 6, FALSE))
	{
		Log("CB1 Write failed\r\n");
		return 1;
	}
	if(ReadByte(hcom) != 0x06)
	{
		Log("CB1 NAK\r\n");
		return 2;
	}

	buf[0] = 0x00;
	buf[1] = 0x01;
	buf[2] = (unsigned char)(rate >> 24) & 0xFF;
	buf[3] = (unsigned char)(rate >> 16) & 0xFF;
	buf[4] = (unsigned char)(rate >> 8) & 0xFF;
	buf[5] = (unsigned char)rate & 0xFF;

	if(sendCommand(hcom, buf, 6, FALSE))
	{
		Log("CB2 Write failed\r\n");
		return 3;
	}
	if(ReadByte(hcom) != 0x06)
	{
		Log("CB2 NAK\r\n");
		return 4;
	}

	if(!SetBaudrate(hcom, rate))
	{
		Log("Warning: SetBaudrate failed\r\n");
	}

	if(setFrameSize(hcom, 4096))
	{
		Log("Framesize failed\r\n");
		return 5;
	}

	return 0;
}

BOOL EndSerialTransfer(HANDLE hcom)
{
	Log("EOT ");
	if(WriteByte(hcom, 0x04))
	{
		Log("Write failed\r\n");
		CloseHandle(hcom);
		return TRUE;
	}
	Log("sent.\r\n");

	// Ô
	PurgeComm(hcom, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);

	CloseHandle(hcom);

	return FALSE;
}

int beginComm(HANDLE* ret)
{
	HANDLE hcom;

	char port[16];
	DWORD baud;

	// Get about COM/Baud info
	GetDlgItemText(hMainWnd, IDC_PORT, port, 16);
	baud = GetDlgItemInt(hMainWnd, IDC_BAUDRATE, NULL, FALSE);

	if(!(hcom = StartSerialTransfer(port)))
		return 1;

	if(ChangeMode(hcom))
	{
		CloseHandle(hcom);
		return 2;
	}

	if(ChangeBaudrate(hcom, baud))
	{
		CloseHandle(hcom);
		return 3;
	}

	*ret = hcom;

	return 0;
}

BOOL endComm(HANDLE hcom)
{
	return EndSerialTransfer(hcom);
}

BOOL getTelNo(HANDLE hcom)
{
	unsigned char buf[32], tmp[32];
	int i;
	DWORD bytes;

	if(WriteByte(hcom, 0x8E))
	{
		Log("ERROR: GTN Write failed\r\n");
		return TRUE;
	}
	for(i = 0;;)
	{
		ReadFile(hcom, buf, 1, &bytes, NULL);
		if(!bytes)
			continue;
		if(buf[0] == 0xAA)	// End of Number
			break;
		if(buf[0] == 0x9A)
			buf[0] = 0x90;
		if(0x90 <= buf[0] && buf[0] <= 0x99)
		{
			tmp[i] = buf[0] - 0x90 + '0';
			i += bytes;
		}
	}

	//Log(tmp);
	SetDlgItemText(hMainWnd, IDC_TELNO, tmp);
	Log("OK");

	return FALSE;
}

void doSomething(void)
{
	HANDLE hcom;
	char port[16];
	DWORD baud;

	GetDlgItemText(hMainWnd, IDC_PORT, port, 16);
	baud = GetDlgItemInt(hMainWnd, IDC_BAUDRATE, NULL, FALSE);

	Log("<<GetInfo>>\r\n");
	Log("COM open...");
	if(!(hcom = StartSerialTransfer(port)))
	{
		Log("failed\r\n");
		return;
	}
	Log("OK\r\n");

	// do peer to peer!!
	{
		unsigned char cmd[4];
		BYTE* buf;
		DWORD len;

		Log("GetTelNo...");
		if(getTelNo(hcom))
		{
			CloseHandle(hcom);
			return;
		}
		Log("\r\n");

		Log("ChangeMode...");
		if(ChangeMode(hcom))
		{
			CloseHandle(hcom);
			return;
		}
		Log("OK\r\n");

		Log("ChangeBaud...");
		if(ChangeBaudrate(hcom, baud))
		{
			CloseHandle(hcom);
			return;
		}
		Log("OK\r\n");

		Log("GetProfile(0000h)...");
		cmd[0] = 0x02;
		cmd[1] = 0x04;
		cmd[2] = 0x00;	// 0000h
		cmd[3] = 0x00;
		if(sendCommand(hcom, cmd, 4, FALSE))
		{
			Log("Send failed\r\n");
			CloseHandle(hcom);
			return;
		}
		if(ReadByte(hcom) != 0x06)
		{
			Log("NOT ACK\r\n");
			WriteByte(hcom, 0x04);
			CloseHandle(hcom);
			return;
		}
		if(getResult(hcom, &buf, &len))
		{
			Log("getResult failed\r\n");
			WriteByte(hcom, 0x04);
			CloseHandle(hcom);
			return;
		}
		Log("Set...");
		{
			BYTE buf2[32];
			DWORD i = 0;

			// skip types? data
			i += ((buf[0] << 8) | buf[1]) * 2 + 2 + 1;

			lstrcpyn(buf2, buf + i + 1, buf[i] + 1);
			SetDlgItemText(hMainWnd, IDC_MANUFACTURE, buf2);
			i += buf[i] + 2;
			strnncopy(buf2, buf + i + 1, buf[i] + 1);
			SetDlgItemText(hMainWnd, IDC_MODEL, buf2);
		}
		hfree(buf);
		Log("OK\r\n");
	}

	if(EndSerialTransfer(hcom))
		return;

	Log("Close connection nicely.\r\n");

	return;
}

void checkLockNo(void)
{
	BYTE buf[16];
	HANDLE hcom;

	char port[16];
	DWORD baud;

	GetDlgItemText(hMainWnd, IDC_PORT, port, 16);
	baud = GetDlgItemInt(hMainWnd, IDC_BAUDRATE, NULL, FALSE);

	Log("<<Check Lock No>>\r\n");
	Log("COM open...");
	if(!(hcom = StartSerialTransfer(port)))
	{
		Log("failed\r\n");
		return;
	}
	Log("OK\r\n");

	Log("ChangeMode...");
	if(ChangeMode(hcom))
	{
		CloseHandle(hcom);
		return;
	}
	Log("OK\r\n");

	Log("ChangeBaud...");
	if(ChangeBaudrate(hcom, baud))
	{
		CloseHandle(hcom);
		return;
	}
	Log("OK\r\n");

	Log("CheckLockNo...");
	buf[0] = 0x00;
	buf[1] = 0x21;
	GetDlgItemText(hMainWnd, IDC_LOCKNO, buf + 2, 9);
	if(sendCommand(hcom, buf, GetDlgItemTextLength(hMainWnd, IDC_LOCKNO) + 2, FALSE))
	{
		Log("ERROR: CLN Send ERR\r\n");
		CloseHandle(hcom);
		return;
	}
	if(Read(hcom, buf, 1))
	{
		Log("ERROR: CLN Read ERR\r\n");
		CloseHandle(hcom);
		return;
	}
	switch(buf[0])
	{
	case 0x06:
		Log("NICE\r\n");
		break;
	case 0x18:
		Log("BAD\r\n");
		break;
	default:
		Log("UNKNOWN CODE ");
		{
			char tmp[3];
			wsprintf(tmp, "%02X", buf[0]);
			Log(tmp);
			Log("\r\n");
		}
	}

	if(EndSerialTransfer(hcom))
		return;

	Log("Close connection nicely.\r\n");
}

BOOL GetDlgItemChecked(HWND hDlg, int nIDDlgItem)
{
	if(SendMessage(GetDlgItem(hDlg, nIDDlgItem), BM_GETCHECK, 0, 0) & BST_CHECKED)
		return TRUE;
	else
		return FALSE;
}

void searchLockNo(void)
{
	BYTE buf[16];
	HANDLE hcom;

	char port[16];
	DWORD baud;
	BOOL longmode;

	DWORD number;

	DWORD starttime, endtime;

	GetDlgItemText(hMainWnd, IDC_PORT, port, 16);
	baud = GetDlgItemInt(hMainWnd, IDC_BAUDRATE, NULL, FALSE);
	longmode = GetDlgItemChecked(hMainWnd, IDC_LNLONG);

	Log("<<Search Lock No>>\r\n");
	if(longmode)
		Log("(Long mode)\r\n");
	Log("COM open...");
	if(!(hcom = StartSerialTransfer(port)))
	{
		Log("failed\r\n");
		return;
	}
	Log("OK\r\n");

	Log("ChangeMode...");
	if(ChangeMode(hcom))
	{
		CloseHandle(hcom);
		return;
	}
	Log("OK\r\n");

	Log("ChangeBaud...");
	if(ChangeBaudrate(hcom, baud))
	{
		CloseHandle(hcom);
		return;
	}
	Log("OK\r\n");

	starttime = GetTickCount();

	// ĂlX^[g
	number = GetDlgItemInt(hMainWnd, IDC_LOCKNO, NULL, FALSE);

	Log("Searching\r\n");
	if(!longmode)
	{
		for(; number <= 9999; number++)
		{
			if(number % 100 == 0)
			{
				wsprintf(buf + 3, "%04d", number);
				SetDlgItemText(hMainWnd, IDC_LOCKNO, buf + 3);
				RedrawWindow(GetDlgItem(hMainWnd, IDC_LOCKNO), NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
				if(GetAsyncKeyState(VK_ESCAPE) & 0x8000)
				{
					number = 10001;
					break;
				}
			}

			buf[0] = 0x00;
			buf[1] = 0x21;
			wsprintf(buf + 2, "%04d", number);

			if(sendCommand(hcom, buf, 2 + 4, FALSE))
			{
				Log("ERROR: CLN Send ERR\r\n");
				CloseHandle(hcom);
				return;
			}
			if(Read(hcom, buf, 1))
			{
				Log("ERROR: CLN Read ERR\r\n");
				CloseHandle(hcom);
				return;
			}
			if(buf[0] == 0x06)
				break;		// YES!!
			if(buf[0] == 0x18)
				continue;	// Bad

			Log("UNKNOWN CODE ");
			{
				char tmp[3];
				wsprintf(tmp, "%02X", buf[0]);
				Log(tmp);
				Log("\r\n");
			}
		}

		endtime = GetTickCount();

		// Translate
		if(number == 10000)
			number = 100000000;
		if(number == 10001)
			number = 100000001;
	}else
	{	// LongMode
		Log("(Longmode: slow)\r\n");

		for(; number <= 99999999; number++)
		{
			if(number % 1000 == 0)
			{
				wsprintf(buf + 3, "%04d", number);
				SetDlgItemText(hMainWnd, IDC_LOCKNO, buf + 3);
				RedrawWindow(GetDlgItem(hMainWnd, IDC_LOCKNO), NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
				if(GetAsyncKeyState(VK_ESCAPE) & 0x8000)
				{
					number = 100000001;
					break;
				}
			}

			buf[0] = 0x00;
			buf[1] = 0x21;
			wsprintf(buf + 2, "%04d", number);

			if(sendCommand(hcom, buf, 2 + strlength(buf + 3), FALSE))
			{
				Log("ERROR: CLN Send ERR\r\n");
				CloseHandle(hcom);
				return;
			}
			if(Read(hcom, buf, 1))
			{
				Log("ERROR: CLN Read ERR\r\n");
				CloseHandle(hcom);
				return;
			}
			if(buf[0] == 0x06)
				break;		// YES!!
			if(buf[0] == 0x18)
				continue;	// Bad

			Log("UNKNOWN CODE ");
			{
				char tmp[3];
				wsprintf(tmp, "%02X", buf[0]);
				Log(tmp);
				Log("\r\n");
			}
		}
		endtime = GetTickCount();
	}

	if(number <= 99999999)
	{
		Log("Found: YOU GOT IT!\r\n");
		SetDlgItemInt(hMainWnd, IDC_LOCKNO, number, FALSE);
	}
	if(number == 100000000)
	{
		SetDlgItemText(hMainWnd, IDC_LOCKNO, "");
		if(longmode)
			Log("Not found: what happened..?\r\n");
		else
			Log("Not found: try longmode please.\r\n");
	}
	if(number == 100000001)
		Log("Stop: Escaped by user.\r\n");

	{
		char msg[80];
		wsprintf(msg, "Elapsed time: %u ms.\r\n", endtime - starttime);
		Log(msg);
	}

	if(EndSerialTransfer(hcom))
		return;

	Log("Close connection nicely.\r\n");
}

typedef struct
{
	HWND hwnd;
	DWORD size;
	char* name;
} gFRCdata;

void getFileResCallback(DWORD pos, LPARAM lpdata)
{
	gFRCdata* data = (gFRCdata*)lpdata;

	{
		MSG msg;
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			DispatchMessage(&msg);
	}

	SendMessage(GetDlgItem(data->hwnd, IDC_FILEPROGRESS), PBM_SETPOS, pos * 1000 / data->size, 0);
	{
		char tmp[256];

		wsprintf(tmp, "%s %d%% (%u/%u)", data->name, pos * 100 / data->size, pos, data->size);
		SetDlgItemText(data->hwnd, IDC_FILESTATUS, tmp);
	}

	return;
}

BYTE downloadFile(HANDLE hcom, char* out, char* name, HWND hWnd)
{
	BYTE* cmd;
	DWORD size;

	{
		char tmp[256];

		wsprintf(tmp, "GetFileInfo %s...", name);
		SetDlgItemText(hWnd, IDC_FILESTATUS, tmp);
	}

	// GetFileSize
	{
		BYTE* res;
		DWORD ressize;

		cmd = halloc(2 + strlength(name) + 1);
		cmd[0] = 0x00;
		cmd[1] = 0x10;
		lstrcpy(cmd + 2, name);
		if(sendCommand(hcom, cmd, 2 + lstrlen(name) + 1, FALSE))
		{
			Log("getFile->SendFileName failed\r\n");
			hfree(cmd);
			return 0;
		}
		{
			BYTE ret = (BYTE)ReadByte(hcom);
			if(ret != 0x06)	// 0x18 = NoFile
			{
				Log("getFile: SFN NAK[");
				LogHex(ret);
				Log("]\r\n");
				hfree(cmd);
				return 0;
			}
		}
		cmd[0] = 0x02;
		cmd[1] = 0x12;
		if(sendCommand(hcom, cmd, 2, FALSE))
		{
			Log("getFile->GetInfo failed\r\n");
			hfree(cmd);
			return 0;	// for prevent leak, etc.
		}
		if(ReadByte(hcom) != 0x06)
		{
			Log("getFile: GI NAK\r\n");
			hfree(cmd);
			return 0;
		}

		hfree(cmd);

		if(getResult(hcom, &res, &ressize))
		{
			Log("getFileInfo: getResult failed\r\n");
			return 0;
		}

		{
			BYTE* b = res + strlength(res) + 1 + 4;

			size = b[0] << 24 | b[1] << 16 | b[2] << 8 | b[3];
		}

		hfree(res);
	}

	{
		char tmp[256];

		wsprintf(tmp, "Query %s...", name);
		SetDlgItemText(hWnd, IDC_FILESTATUS, tmp);
	}

	cmd = halloc(2 + strlength(name) + 1);
	cmd[0] = 0x02;
	cmd[1] = 0x10;
	strcopy(cmd + 2, name);
	if(sendCommand(hcom, cmd, 2 + strlength(name) + 1, FALSE))
		return 0;

	{
		WORD retval = ReadByte(hcom);

		if(retval == 0x06)	// ACK
		{
			BYTE* data;
			DWORD dsize;
			gFRCdata gfrcd = {hWnd, size, name};

			if(getResultWC(hcom, &data, &dsize, getFileResCallback, (LPARAM)&gfrcd))
			{
				Log("getResult failed\r\n");
				return 0;
			}

			SetDlgItemText(hWnd, IDC_FILESTATUS, "Saving");

			{
				HANDLE hf;
				DWORD written;

				if((hf = CreateFile(out, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL)) == INVALID_HANDLE_VALUE)
				{
					hfree(data);
					Log("CreateFile failed!?\r\n");
					return 0;
				}

				if(!WriteFile(hf, data, dsize, &written, NULL))
					Log("WriteFile failed!?\r\n");

				CloseHandle(hf);
			}

			SetDlgItemText(hWnd, IDC_FILESTATUS, "Done");

			hfree(data);
		}

		return (BYTE)retval;
	}
}

BYTE deleteFile(HANDLE hcom, char* name, HWND hWnd)
{
	BYTE* cmd;
	DWORD size;

	// GetFileSize(for exist check)
	if(0)
	{
		BYTE* res;
		DWORD ressize;

		cmd = halloc(2 + strlength(name) + 1);
		cmd[0] = 0x00;
		cmd[1] = 0x10;
		lstrcpy(cmd + 2, name);
		if(sendCommand(hcom, cmd, 2 + lstrlen(name) + 1, FALSE))
		{
			Log("getFile->SendFileName failed\r\n");
			hfree(cmd);
			return 0;
		}
		if(ReadByte(hcom) != 0x06)
		{
			Log("getFile: SFN NAK\r\n");
			hfree(cmd);
			return 0;
		}
		cmd[0] = 0x02;
		cmd[1] = 0x12;
		if(sendCommand(hcom, cmd, 2, FALSE))
		{
			Log("getFile->GetInfo failed\r\n");
			hfree(cmd);
			return 0;	// for prevent leak, etc.
		}
		if(ReadByte(hcom) != 0x06)
		{
			Log("getFile: GI NAK\r\n");
			hfree(cmd);
			return 0;
		}

		hfree(cmd);

		if(getResult(hcom, &res, &ressize))
		{
			Log("getFileInfo: getResult failed\r\n");
			return 0;
		}

		{
			BYTE* b = res + strlength(res) + 1 + 4;

			size = b[0] << 24 | b[1] << 16 | b[2] << 8 | b[3];
		}

		hfree(res);
	}

	Log("SaveFile(0byte)...");

	if(!(cmd = halloc(2 + strlength(name) + 1 + 4)))
		return 0;

	cmd[0] = 0x01;
	cmd[1] = 0x10;
	strcopy(cmd + 2, name);
	cmd[2 + strlength(name) + 1 + 0] = 0;
	cmd[2 + strlength(name) + 1 + 1] = 0;
	cmd[2 + strlength(name) + 1 + 2] = 0;
	cmd[2 + strlength(name) + 1 + 3] = 0;

	if(sendCommand(hcom, cmd, 2 + strlength(name) + 1 + 4, FALSE))
	{
		hfree(cmd);
		return 0;
	}
	{
		BYTE ret = (BYTE)ReadByte(hcom);

		if(ret != 0x06)	// 0x18 = NoFile
		{
			Log("NAK[");
			LogHex(ret);
			Log("]");
			hfree(cmd);
			return 0;
		}
	}
 
	hfree(cmd);

	Log("data...");

	if(sendCommand(hcom, NULL, 0, TRUE))
		return 0;
	return (BYTE)ReadByte(hcom);
}

void getFileListInfo(HWND hfw)
{
	HANDLE hcom;

	EnableWindow(GetDlgItem(hfw, IDC_GETFILELIST), FALSE);
	EnableWindow(GetDlgItem(hfw, IDC_GETFILEINFO), FALSE);
	EnableWindow(GetDlgItem(hfw, IDOK), FALSE);

	if(beginComm(&hcom))
	{
		Log("Cannot begin comm\r\n");
		return;
	}

	Log("Receiving info...");
	{
		WORD i;
		WORD files = ListView_GetItemCount(GetDlgItem(hfw, IDC_FILELIST));
		char name[256];

		SetDlgItemText(hfw, IDC_STATUS, "Getting Fileinfo...");
		SendMessage(GetDlgItem(hfw, IDC_PROGRESS), PBM_SETRANGE, 0, MAKELPARAM(0, files));
		SendMessage(GetDlgItem(hfw, IDC_PROGRESS), PBM_SETPOS, 0, 0);

		for(i = 0; i < files; i++)
		{
			LV_ITEM lvi = {0};
			BYTE* res;
			BYTE* cmd;
			DWORD size;
			int ii;

			if(GetAsyncKeyState(VK_ESCAPE) & 0x8000)
				break;

			{
				MSG msg;
				if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
					DispatchMessage(&msg);
			}

			// for GettingSort bug
			{
				LV_FINDINFO lvf;

				lvf.flags = LVFI_PARAM;
				lvf.lParam = i;
				ii = ListView_FindItem(GetDlgItem(hfw, IDC_FILELIST), -1, &lvf);

				ListView_GetItemText(GetDlgItem(hfw, IDC_FILELIST), ii, 0, name, sizeof(name));
			}

			cmd = halloc(2 + strlength(name) + 1);
			cmd[0] = 0x00;
			cmd[1] = 0x10;
			strcopy(cmd + 2, name);
			if(sendCommand(hcom, cmd, 2 + strlength(name) + 1, FALSE))
			{
				Log("getFileInfo->SendFileName failed\r\n");
				break;	// for prevent leak, etc.
			}
			if(ReadByte(hcom) != 0x06)
			{
				Log("getFileInfo: SFN NAK\r\n");
				break;
			}
			cmd[0] = 0x02;
			cmd[1] = 0x12;
			if(sendCommand(hcom, cmd, 2, FALSE))
			{
				Log("getFileInfo->GetInfo failed\r\n");
				break;	// for prevent leak, etc.
			}
			if(ReadByte(hcom) != 0x06)
			{
				Log("getFileInfo: GI NAK\r\n");
				break;
			}

			hfree(cmd);

			if(getResult(hcom, &res, &size))
			{
				Log("getFileInfo: getResult failed\r\n");
				break;
			}

			{
				BYTE* b;

				b = res + strlength(res) + 1 + 4;

				{
					char tmp[16];

					wsprintf(tmp, "%d", b[0] << 24 | b[1] << 16 | b[2] << 8 | b[3]);
					ListView_SetItemText(GetDlgItem(hfw, IDC_FILELIST), ii, 2, tmp);
				}
				b += 4;

				{
					char datestr[32];
					struct{
						struct{
							int y;
							int m;
							int d;
						}date;
						struct{
							int h;
							int m;
							int s;
						}time;
					}stamp;

					stamp.date.y = atodn(b + 0, 4);
					stamp.date.m = atodn(b + 4, 2);
					stamp.date.d = atodn(b + 6, 2);
					stamp.time.h = atodn(b + 8, 2);
					stamp.time.m = atodn(b + 10, 2);
					stamp.time.s = atodn(b + 12, 2);
					wsprintf(datestr, "%04d/%02d/%02d %02d:%02d:%02d", stamp.date.y, stamp.date.m, stamp.date.d, stamp.time.h, stamp.time.m, stamp.time.s);
					ListView_SetItemText(GetDlgItem(hfw, IDC_FILELIST), ii, 3, datestr);
				}
				b += strlength(b) + 1;

				{
					char tmp[64];
					int j;

					tmp[0] = '\0';
					for(j = 0; j < 16; j++)
					{
						char hex[4];
						wsprintf(hex, "%02X ", b[j]);
						strplus(tmp, hex);
					}

					ListView_SetItemText(GetDlgItem(hfw, IDC_FILELIST), ii, 4, tmp);
				}
			}

			hfree(res);

			{
				char tmp[80];

				wsprintf(tmp, "Getting Fileinfo... %d/%d", i, files);
				SetDlgItemText(hfw, IDC_STATUS, tmp);
			}
			SendMessage(GetDlgItem(hfw, IDC_PROGRESS), PBM_SETPOS, i, 0);
		}
	}

	EnableWindow(GetDlgItem(hfw, IDC_GETFILELIST), TRUE);
	EnableWindow(GetDlgItem(hfw, IDC_GETFILEINFO), TRUE);
	EnableWindow(GetDlgItem(hfw, IDOK), TRUE);

	if(GetAsyncKeyState(VK_ESCAPE) & 0x8000)
		SetDlgItemText(hfw, IDC_STATUS, "GetFileInfo aborted by user.");
	else
		SetDlgItemText(hfw, IDC_STATUS, "GetFileInfo accomplished.");

	if(endComm(hcom))
	{
		Log("Illegal endComm\r\n");
	}

	return;
}

void getFileList(HWND hfw)
{
	HANDLE hcom;

	EnableWindow(GetDlgItem(hfw, IDOK), FALSE);
	EnableWindow(GetDlgItem(hfw, IDC_GETFILELIST), FALSE);

	Log("<<GetFiles>>\r\n");

	Log("beginComm...");
	if(beginComm(&hcom))
	{
		Log("failed\r\n");
		return;
	}
	Log("OK\r\n");

	{
		BYTE* list;
		DWORD size;

		SetDlgItemText(hfw, IDC_STATUS, "Getting Filelist...");
		SendMessage(GetDlgItem(hfw, IDC_PROGRESS), PBM_SETRANGE, 0, MAKELPARAM(0, 1));
		SendMessage(GetDlgItem(hfw, IDC_PROGRESS), PBM_SETPOS, 0, 0);
		SendMessage(GetDlgItem(hfw, IDC_FILELIST), LVM_DELETEALLITEMS, 0, 0);

		Log("GetList...");
		{
			BYTE buf[2] = {0x02, 0x14};

			if(sendCommand(hcom, buf, 2, FALSE))
			{
				Log("failed\r\n");
				return;
			}
		}
		if(ReadByte(hcom) != 0x06)
		{
			Log("NAK\r\n");
			return;
		}

		Log("Receiving...");
		if(getResult(hcom, &list, &size))
		{
			Log("failed\r\n");
			return;
		}
		Log("OK\r\n");

		{
			WORD i;
			WORD files = (list[0] << 8) | list[1];
			BYTE* b = list + 2;

			for(i = 0; i < files; i++)
			{
				LV_ITEM lvi = {0};

				lvi.mask = LVIF_TEXT | LVIF_PARAM;
				lvi.pszText = b;
				lvi.iItem = i;
				lvi.lParam = i;
				ListView_InsertItem(GetDlgItem(hfw, IDC_FILELIST), &lvi);

				{
					char ext[16];
					DWORD l = strlength(b);
					BYTE* x = b + l - 1;

					while(l && *x != '.')
						l--, x--;

					strcopy(ext, x + 1);
					ListView_SetItemText(GetDlgItem(hfw, IDC_FILELIST), i, 1, ext);
				}

				b += strlength(b) + 1;
			}
		}

		EnableWindow(GetDlgItem(hfw, IDOK), TRUE);
		EnableWindow(GetDlgItem(hfw, IDC_GETFILELIST), TRUE);
		EnableWindow(GetDlgItem(hfw, IDC_GETFILEINFO), TRUE);
	}
	Log("OK\r\n");

	SetDlgItemText(hfw, IDC_STATUS, "Closing connection...");

	Log("Close connection ");
	if(EndSerialTransfer(hcom))
	{
		Log("illegally!\r\n");
		return;
	}

	Log("nicely.\r\n");

	SetDlgItemText(hfw, IDC_STATUS, "GetFileList accomplished.");

	return;
}

int CALLBACK sortFileListCallBack(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	LV_FINDINFO lvf;
	int ii1, ii2;
	static char buf1[256], buf2[256];
	int ret;

	lvf.flags = LVFI_PARAM;
	lvf.lParam = lParam1;
	ii1 = ListView_FindItem(GetDlgItem(hFilesWnd, IDC_FILELIST), -1, &lvf);

	lvf.lParam = lParam2;
	ii2 = ListView_FindItem(GetDlgItem(hFilesWnd, IDC_FILELIST), -1, &lvf);

	ListView_GetItemText(GetDlgItem(hFilesWnd, IDC_FILELIST), ii1, LOWORD(lParamSort), buf1, sizeof(buf1));
	ListView_GetItemText(GetDlgItem(hFilesWnd, IDC_FILELIST), ii2, LOWORD(lParamSort), buf2, sizeof(buf2));

	if(HIBYTE(HIWORD(lParamSort)))
	{
		// NumericSort
		DWORD s1, s2;
		int l1, l2;

		l1 = lstrlen(buf1);
		l2 = lstrlen(buf2);
		if(!l1 && !l2)
			ret = 0;
		else
			if(!l1 && l2)
				ret = -1;
			else
				if(l1 && !l2)
					ret = 1;
				else
				{
					s1 = atod(buf1);
					s2 = atod(buf2);

					if(s1 == s2)
						ret = 0;
					if(s1 < s2)
						ret = -1;
					else
						ret = 1;
				}
	}else
	{
		// ASCII Sort
		ret = lstrcmp(buf1, buf2);
	}
	if(LOBYTE(HIWORD(lParamSort)))
		ret *= -1;

	return ret;
}

BOOL CALLBACK FilesWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static char outdir[256];

	switch(msg)
	{
	case WM_INITDIALOG:
		outdir[0] = '\0';
		return TRUE;	// set focus
	case WM_LBUTTONDOWN:
		SendMessage(hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0);
		break;
	case WM_CLOSE:
		EndDialog(hWnd, 0);
		hFilesWnd = NULL;
		break;
	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
		case 0:
			switch(LOWORD(wParam))
			{
			case IDOK:
				PostMessage(hWnd, WM_CLOSE, 0, 0);
				break;
			case IDC_GETFILELIST:
				getFileList(hWnd);
				break;
			case IDC_GETFILEINFO:
				getFileListInfo(hWnd);
				break;
			case IDC_OUTDIR:
				{
					BROWSEINFO bi = {0};
					LPITEMIDLIST il;
					char path[MAX_PATH];

					bi.hwndOwner = hWnd;
					bi.pidlRoot = NULL;
					bi.lpszTitle = "Download to...";
					bi.ulFlags = BIF_RETURNONLYFSDIRS;

					if(il = SHBrowseForFolder(&bi))
					{
						SHGetPathFromIDList(il, path);
						CoTaskMemFree(il);

						addEndYen(path);

						strcopy(outdir, path);
						SetDlgItemText(hWnd, IDC_OUTDIR, outdir);
					}
				}
				break;
			case ID_GETFILE:
				if(!strlength(outdir))
					SendMessage(hWnd, WM_COMMAND, MAKEWPARAM(IDC_OUTDIR, 0), 0);
				if(strlength(outdir))
				{
					HANDLE hcom;
					char port[16];
					DWORD baud;

					// start!
					GetDlgItemText(hMainWnd, IDC_PORT, port, 16);
					baud = GetDlgItemInt(hMainWnd, IDC_BAUDRATE, NULL, FALSE);

					Log("<<GetFile>>\r\n");
					Log("Open COM...");
					if(!(hcom = StartSerialTransfer(port)))
					{
						Log("failed\r\n");
						break;
					}
					Log("OK\r\n");

					Log("ChangeMode...");
					if(ChangeMode(hcom))
						goto getFileError;
					Log("OK\r\n");

					Log("ChangeBaud...");
					if(ChangeBaudrate(hcom, baud))
						goto getFileError;
					Log("OK\r\n");

					{
						int i;
						int count = 0;
						int selected = ListView_GetSelectedCount(GetDlgItem(hWnd, IDC_FILELIST));

						SendMessage(GetDlgItem(hWnd, IDC_PROGRESS), PBM_SETRANGE, 0, MAKELPARAM(0, selected));
						SendMessage(GetDlgItem(hWnd, IDC_PROGRESS), PBM_SETPOS, 0, 0);

						for(i = 0; i < ListView_GetItemCount(GetDlgItem(hWnd, IDC_FILELIST)); i++)
						{
							if(ListView_GetItemState(GetDlgItem(hWnd, IDC_FILELIST), i, LVIS_SELECTED) & LVIS_SELECTED)
							{
								char name[256];
								char fn[256];

								if(GetAsyncKeyState(VK_ESCAPE) & 0x8000)
									break;

								ListView_GetItemText(GetDlgItem(hWnd, IDC_FILELIST), i, 0, name, 256);

								strcopy(fn, outdir);
								strplus(fn, name);

								Log("Receiving ");
								Log(name);
								Log("...");

								{
									char tmp[256];

									wsprintf(tmp, "Getting(%d/%d) %s...", count, selected, name);
									SetDlgItemText(hWnd, IDC_STATUS, tmp);
									SendMessage(GetDlgItem(hWnd, IDC_PROGRESS), PBM_SETPOS, count, 0);
									count++;
								}

								{
									BYTE ret = downloadFile(hcom, fn, name, hWnd);
									switch(ret)
									{
									case 0x06:
										Log("OK\r\n");
										break;
									case 0x18:
										Log("NAK\r\n");
										break;
									default:
										Log("Unknown[");
										LogHex(ret);
										Log("]\r\n");
										break;
									}
								}

								{
									char tmp[256];

									wsprintf(tmp, "GetFin %s...", name);
									SetDlgItemText(hWnd, IDC_STATUS, tmp);
									SendMessage(GetDlgItem(hWnd, IDC_PROGRESS), PBM_SETPOS, count, 0);
								}
							}
						}
					}

					// kokorahen naosite.
getFileErrorResume:
					Log("Close connection ");
					if(EndSerialTransfer(hcom))
						Log("illegally!\r\n");
					else
						Log("nicely\r\n");

					if(GetAsyncKeyState(VK_ESCAPE) & 0x8000)
						SetDlgItemText(hWnd, IDC_STATUS, "GetFile aborted by user.");
					else
						SetDlgItemText(hWnd, IDC_STATUS, "GetFile accomplished.");
					SetDlgItemText(hWnd, IDC_FILESTATUS, "");
					SendMessage(GetDlgItem(hWnd, IDC_FILEPROGRESS), PBM_SETPOS, 0, 0);

					break;
getFileError:
					Log("failed!\r\n");
					goto getFileErrorResume;
				}
				break;
			case ID_DELETEFILE:
				{
					DWORD selected = ListView_GetSelectedCount(GetDlgItem(hWnd, IDC_FILELIST));
					char tmp[256];

					wsprintf(tmp, "YOU WILL LOST SELECTED %d FILE(S)!\n\nA R E  Y O U  S U R E ?", selected);

					if(MessageBox(hWnd, tmp, "LAST WARNING", MB_ICONWARNING | MB_YESNO) == IDYES)
					{
						int i;
						int count = 0;
						int selected = ListView_GetSelectedCount(GetDlgItem(hWnd, IDC_FILELIST));
						HANDLE hcom;

						Log("<<DELETE FILE>>\r\n");

						Log("beginComm...");
						if(beginComm(&hcom))
						{
							Log("failed\r\n");
							break;
						}
						Log("OK\r\n");

						SendMessage(GetDlgItem(hWnd, IDC_PROGRESS), PBM_SETRANGE, 0, MAKELPARAM(0, selected));
						SendMessage(GetDlgItem(hWnd, IDC_PROGRESS), PBM_SETPOS, 0, 0);

						for(i = 0; i < ListView_GetItemCount(GetDlgItem(hWnd, IDC_FILELIST)); i++)
						{
							if(ListView_GetItemState(GetDlgItem(hWnd, IDC_FILELIST), i, LVIS_SELECTED) & LVIS_SELECTED)
							{
								char name[256];

								if(GetAsyncKeyState(VK_ESCAPE) & 0x8000)
									break;

								{
									MSG msg;
									if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
										DispatchMessage(&msg);
								}

								ListView_GetItemText(GetDlgItem(hWnd, IDC_FILELIST), i, 0, name, 256);

								Log("Deleting ");
								Log(name);
								Log("...");

								{
									char tmp[256];

									wsprintf(tmp, "Deleting(%d/%d)...", count, selected);
									SetDlgItemText(hWnd, IDC_STATUS, tmp);
									SetDlgItemText(hWnd, IDC_FILESTATUS, name);
									SendMessage(GetDlgItem(hWnd, IDC_PROGRESS), PBM_SETPOS, count, 0);
									count++;
								}

								{
									BYTE ret = deleteFile(hcom, name, hWnd);
									switch(ret)
									{
									case 0x06:
										Log("OK\r\n");
										break;
									case 0x18:
										Log("NAK\r\n");
										break;
									default:
										Log("Unknown[");
										LogHex(ret);
										Log("]\r\n");
										break;
									}
								}

								{
									char tmp[256];

									wsprintf(tmp, "Deleted(%d/%d)", count, selected);
									SetDlgItemText(hWnd, IDC_STATUS, tmp);
									SendMessage(GetDlgItem(hWnd, IDC_PROGRESS), PBM_SETPOS, count, 0);
								}
							}
						}

						// kokorahen naosite.
						Log("Close connection ");
						if(EndSerialTransfer(hcom))
							Log("illegally!\r\n");
						else
							Log("nicely\r\n");

						if(GetAsyncKeyState(VK_ESCAPE) & 0x8000)
							SetDlgItemText(hWnd, IDC_STATUS, "DeleteFile aborted by user.");
						else
							SetDlgItemText(hWnd, IDC_STATUS, "DeleteFile accomplished.");
						SetDlgItemText(hWnd, IDC_FILESTATUS, "");

						MessageBox(hWnd, "Reopen FileList to refresh list, please...(ǂĂ蔲łB܂B)", "notice", MB_ICONASTERISK | MB_OK);

						break;
					}
				}
				break;
			}
		}
		break;
	case WM_NOTIFY:
		switch((int)wParam)
		{
		case IDC_FILELIST:
			{
				LV_DISPINFO* lvi = (LV_DISPINFO*)lParam;

				if(lvi->hdr.code == LVN_COLUMNCLICK)
				{
					NM_LISTVIEW* nmlv = (NM_LISTVIEW*)lParam;
					static int sortcolumn = -1;
					static BOOL sortreverse = FALSE;

					if(nmlv->iSubItem != sortcolumn)
					{
						sortreverse = FALSE;
						sortcolumn = nmlv->iSubItem;
					}else
						sortreverse = sortreverse ? FALSE : TRUE;	// reverse flag

					{
						LV_COLUMN lvc;

						lvc.mask = LVCF_FMT;
						if(!ListView_GetColumn(GetDlgItem(hWnd, IDC_FILELIST), nmlv->iSubItem, &lvc))
							MessageBeep(MB_ICONERROR);
						if((lvc.fmt & 0x000F) == LVCFMT_RIGHT)	// What 0x4000?
							// NumericSort
							ListView_SortItems(GetDlgItem(hWnd, IDC_FILELIST), sortFileListCallBack, MAKELPARAM(nmlv->iSubItem, MAKEWORD(sortreverse, TRUE)));
						else
							// ASCII Sort
							ListView_SortItems(GetDlgItem(hWnd, IDC_FILELIST), sortFileListCallBack, MAKELPARAM(nmlv->iSubItem, MAKEWORD(sortreverse, FALSE)));
					}
				}
				break;
			}
		}
		break;
	case WM_CONTEXTMENU:
		if((HWND)wParam == GetDlgItem(hWnd, IDC_FILELIST) && ListView_GetSelectedCount(GetDlgItem(hWnd, IDC_FILELIST)))
		{
			HMENU hpm = LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_FILEPOPUP));
			HMENU hm = GetSubMenu(hpm, 0);

			TrackPopupMenu(hm, 0, LOWORD(lParam), HIWORD(lParam), 0, hWnd, NULL);
			DestroyMenu(hm);
			DestroyMenu(hpm);
		}
		break;
	}

	return FALSE;
}

void getFiles(void)
{
	if(hFilesWnd)
	{
		SetActiveWindow(hFilesWnd);
		return;
	}

	hFilesWnd = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_FILESDIALOG), hMainWnd, FilesWndProc);

	SendMessage(GetDlgItem(hFilesWnd, IDC_FILELIST), LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT, 0xFFFFFFFF);

	{
		LV_COLUMN lvc = {0};

		lvc.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_FMT;
		lvc.cx = 200;
		lvc.pszText = "Filename";
		lvc.fmt = LVCFMT_LEFT;
		ListView_InsertColumn(GetDlgItem(hFilesWnd, IDC_FILELIST), 0, &lvc);
		lvc.cx = 60;
		lvc.pszText = "Ext";
		lvc.fmt = LVCFMT_LEFT;
		ListView_InsertColumn(GetDlgItem(hFilesWnd, IDC_FILELIST), 1, &lvc);
		lvc.cx = 60;
		lvc.pszText = "Size";
		lvc.fmt = LVCFMT_RIGHT;
		ListView_InsertColumn(GetDlgItem(hFilesWnd, IDC_FILELIST), 2, &lvc);
		lvc.cx = 120;
		lvc.pszText = "Time";
		lvc.fmt = LVCFMT_LEFT;
		ListView_InsertColumn(GetDlgItem(hFilesWnd, IDC_FILELIST), 3, &lvc);
		lvc.cx = 100;
		lvc.pszText = "ExtraData";
		lvc.fmt = LVCFMT_LEFT;
		ListView_InsertColumn(GetDlgItem(hFilesWnd, IDC_FILELIST), 4, &lvc);
	}

	SendMessage(GetDlgItem(hFilesWnd, IDC_FILEPROGRESS), PBM_SETRANGE, 0, MAKELPARAM(0, 1000));
	SetDlgItemText(hFilesWnd, IDC_FILESTATUS, "");
	SetDlgItemText(hFilesWnd, IDC_STATUS, "Click [GetFileList].");

	ShowWindow(hFilesWnd, SW_SHOW);

	return;
}

void putFile(char* name, char* fn)
{
	HANDLE hf = NULL;
	BYTE* data = NULL;
	DWORD dsize;
	DWORD read;
	BYTE* cmd = NULL;

	HANDLE hcom = NULL;

	Log("<<PutFile>>\r\n");

	Log("OpenSrc...");

	if((hf = CreateFile(fn, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
		goto error;

	Log("OK\r\n");
	Log("Reading...");

	dsize = GetFileSize(hf, NULL);

	if(!dsize)
	{
		Log("Can't send size 0\r\n");
		goto error;
	}

	if(!(data = halloc(dsize)))
		goto error;

	if(!ReadFile(hf, data, dsize, &read, NULL))
		goto error;

	CloseHandle(hf), hf = NULL;

	Log("OK\r\n");
	Log("Sending...");

	if(beginComm(&hcom))
		goto error;

	Log("SetFile...");

	if(!(cmd = halloc(2 + strlength(name) + 1 + 4)))
		goto error;

	cmd[0] = 0x01;
	cmd[1] = 0x10;
	strcopy(cmd + 2, name);
	cmd[2 + strlength(name) + 1 + 0] = (BYTE)((dsize >> 24) & 0xFF);
	cmd[2 + strlength(name) + 1 + 1] = (BYTE)((dsize >> 16) & 0xFF);
	cmd[2 + strlength(name) + 1 + 2] = (BYTE)((dsize >>  8) & 0xFF);
	cmd[2 + strlength(name) + 1 + 3] = (BYTE)((dsize      ) & 0xFF);

	if(sendCommand(hcom, cmd, 2 + strlength(name) + 1 + 4, FALSE))
		goto error;
	if(ReadByte(hcom) != 0x06)
	{
		Log("NAK");
		goto error;
	}

	hfree(cmd), cmd = NULL;

	Log("data...");

	if(sendCommand(hcom, data, dsize, TRUE))
		goto error;
	Log("last");
	if(ReadByte(hcom) != 0x06)
		goto error;

	Log("\r\n");
	Log("Closing...");

	if(endComm(hcom))
		goto error;
	hcom = NULL;

	Log("OK\r\n");

	hfree(data);

	return;
error:
	Log("failed\r\n");
	if(hf)
		CloseHandle(hf);
	if(data)
		hfree(data);
	if(cmd)
		hfree(cmd);
	if(hcom)
		if(endComm(hcom))
			CloseHandle(hcom);
	return;
}

// Handler //
BOOL CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		hMainWnd = hWnd;

		SetWindowText(hWnd, "KMprototype 4 au Keitai");
		{
			HICON hi = LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_MAINICON), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
			SendMessage(hWnd, WM_SETICON, ICON_SMALL, (LPARAM)hi);
			DestroyIcon(hi);
		}
		{
			HICON hi = LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_MAINICON), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR);
			SendMessage(hWnd, WM_SETICON, ICON_BIG, (LPARAM)hi);
			DestroyIcon(hi);
		}

		SetDlgItemText(hWnd, IDC_PORT, "COM5");
		SetDlgItemInt(hWnd, IDC_BAUDRATE, /*115200*/230400, FALSE);

		return TRUE;	// set default focus
	case WM_CLOSE:
		EndDialog(hWnd, 0);
		break;
	case WM_LBUTTONDOWN:
		SendMessage(hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0);
		break;
	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
		case 0:
			switch(LOWORD(wParam))
			{
			case IDOK:
				PostMessage(hWnd, WM_CLOSE, 0, 0);
				break;
			case IDC_RUN:
				doSomething();
				break;
			case IDC_LNCHECK:
				checkLockNo();
				break;
			case IDC_LNSEARCH:
				searchLockNo();
				break;
			case IDC_FILES:
				getFiles();
				break;
			case IDC_PUTFILE:
				{
					OPENFILENAME ofn = {0};
					char fname[MAX_PATH];
					char name[MAX_PATH];

					ofn.lStructSize = sizeof(ofn);
					ofn.Flags = OFN_FILEMUSTEXIST;
					ofn.hInstance = GetModuleHandle(NULL);
					ofn.hwndOwner = hWnd;
					fname[0] = '\0';
					ofn.lpstrFile = fname;
					ofn.nMaxFile = sizeof(fname);
					ofn.lpstrFileTitle = name;
					ofn.nMaxFileTitle = sizeof(name);
					ofn.lpstrFilter = "All files(*.*)\0*.*\0";
					ofn.lpstrTitle = "Send file";

					if(GetOpenFileName(&ofn))
						putFile(name, fname);
				}
				break;
			case IDC_DEBUGCLEAR:
				SetDlgItemText(hWnd, IDC_DEBUG, "");
				break;
			case IDC_APPICON:
				{
					char name[MAX_PATH + 1];
					char* vi;
					DWORD size;

					GetModuleFileName(NULL, name, MAX_PATH);
					size = GetFileVersionInfoSize(name, 0);
					if(vi = halloc(size))
					{
						GetFileVersionInfo(name, 0, size, vi);
						{
							VS_FIXEDFILEINFO* ver = (VS_FIXEDFILEINFO*)(vi + 40);

							// nameg
							wsprintf(name, "KM Version %d.%d.%d.%d", HIWORD(ver->dwFileVersionMS), LOWORD(ver->dwFileVersionMS),
																HIWORD(ver->dwFileVersionLS), LOWORD(ver->dwFileVersionLS));
							MessageBox(hWnd, name, "About KM", MB_ICONASTERISK | MB_OK);
						}
						hfree(vi);
					}
				}
				break;
			}
			break;
		}
		break;
	}

	return FALSE;
}

// main routine //
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShowCmd)
{
	DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MAINDIALOG), NULL, MainWndProc, 0);

	ExitProcess(0);
}
